# StridedViews

| **Build Status** | **Coverage** | **Quality assurance** |
|:----------------:|:------------:|:---------------------:|
| [![CI][ci-img]][ci-url] | [![Codecov][codecov-img]][codecov-url] | [![Aqua QA][aqua-img]][aqua-url] |

[ci-img]:
    https://github.com/QuantumKitHub/StridedViews.jl/actions/workflows/CI.yml/badge.svg?branch=main
[ci-url]:
    https://github.com/QuantumKitHub/StridedViews.jl/actions/workflows/CI.yml?query=branch%3Amain

[codecov-img]: https://codecov.io/gh/QuantumKitHub/StridedViews.jl/branch/main/graph/badge.svg
[codecov-url]: https://codecov.io/gh/QuantumKitHub/StridedViews.jl

[aqua-img]: https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg
[aqua-url]: https://github.com/JuliaTesting/Aqua.jl

<!-- [genie-img]: https://shields.io/endpoint?url=https://pkgs.genieframework.com/api/v1/badge/Strided
[genie-url]: https://pkgs.genieframework.com?packages=Strided
 -->
<!-- [![PkgEval](https://JuliaCI.github.io/NanosoldierReports/pkgeval_badges/S/StridedViews.svg)](https://JuliaCI.github.io/NanosoldierReports/pkgeval_badges/report.html) -->

StridedViews.jl exports a single struct type `StridedView` for representing a strided view
over a contiguous parent array, as represented by the abstract type `DenseArray`.

See [Strided.jl](http://github.com/QuantumKitHub/Strided.jl) for more functionality.

---

The type `StridedView` provides a view into a parent array of type `DenseArray` such that
the resulting view is strided, i.e. any dimension has an associated stride, such that e.g.
```julia
getindex(A, i₁, i₂, i₃, ...) = A.op(A.parent[offset + 1 + (i₁-1)*s₁ + (i₂-1)*s₂ + (i₃-1)*s₃ + ...])
```
with `sⱼ = stride(A, iⱼ)`. There are no further assumptions on the strides, e.g. they are
not assumed to be monotonously increasing or have `s₁ == 1`. Furthermore, `A.op` can be any
of the operations `identity`, `conj`, `transpose` or `adjoint` (the latter two are
equivalent to the former two if `eltype(A) <: Number`). Since these operations are their own
inverse, they are also used in the corresponding `setindex!`.

This definition enables a `StridedView` to be lazy (i.e. returns just another `StridedView`
over the same parent data) under application of `conj`, `transpose`, `adjoint`,
`permutedims` and indexing (`getindex`) with `Union{Integer, Colon,
AbstractRange{<:Integer}}` (a.k.a slicing). The function `sview` is exported to directly
create a sliced (and thus strided) view over a given parent array.

Furthermore, the strided structure can be retained under certain `reshape` operations, but
not all of them. Any dimension can always be split into smaller dimensions, but two
subsequent dimensions `i` and `i+1` can only be joined if `stride(A,i+1) ==
size(A,i)*stride(A,i)`. Instead of overloading `reshape`, Strided.jl provides a separate
function `sreshape` which returns a `StridedView` over the same parent data, or throws a
runtime error if this is impossible.

### News

Since StridedViews v0.4.0, the `StridedView` type attempts to generate less specializations
by normalizing the parent array type. In particular, for `DenseArray` parents we attempt to
reshape the parent array to a vector, and for `Memory`-based arrays (Julia v1.11+) we unpack
the `Memory` object directly. This should improve compile times.

using Test
using Aqua
using LinearAlgebra
using Random
using StridedViews
using Adapt
using PtrArrays, JLArrays, CUDACore, AMDGPU, Metal

Random.seed!(1234)

is_buildkite = get(ENV, "BUILDKITE", "false") == "true"

if !is_buildkite
    @testset "construction of StridedView" begin
        @testset for T1 in (Float32, Float64, Complex{Float32}, Complex{Float64})
            A1 = randn(T1, (60, 60))
            B1 = StridedView(A1)
            C1 = StridedView(B1)
            @test isstrided(A1)
            @test isstrided(B1)
            @test C1 === B1
            @test parent(B1) == reshape(A1, :)
            @test Base.elsize(B1) == Base.elsize(A1)
            for op1 in (identity, conj, transpose, adjoint)
                if op1 == transpose || op1 == adjoint
                    @test op1(A1) == op1(B1) == StridedView(op1(A1))
                else
                    @test op1(A1) == op1(B1)
                end
                for op2 in (identity, conj, transpose, adjoint)
                    @test op2(op1(A1)) == op2(op1(B1))
                end
            end

            A2 = view(A1, 1:36, 1:20)
            @test isstrided(A2)
            B2 = StridedView(A2)
            for op1 in (identity, conj, transpose, adjoint)
                if op1 == transpose || op1 == adjoint
                    @test op1(A2) == op1(B2) == StridedView(op1(A2))
                else
                    @test op1(A2) == op1(B2)
                end
                for op2 in (identity, conj, transpose, adjoint)
                    @test op2(op1(A2)) == op2(op1(B2))
                end
            end

            A3 = reshape(A1, 360, 10)
            @test isstrided(A3)
            @test !isstrided(reshape(A1', 10, 360))
            B3 = StridedView(A3)
            @test size(A3) == size(B3)
            @test strides(A3) == strides(B3)
            @test stride(A3, 1) == stride(B3, 1)
            @test stride(A3, 2) == stride(B3, 2)
            @test stride(A3, 3) == stride(B3, 3)
            for op1 in (identity, conj, transpose, adjoint)
                if op1 == transpose || op1 == adjoint
                    @test op1(A3) == op1(B3) == StridedView(op1(A3))
                else
                    @test op1(A3) == op1(B3)
                end
                for op2 in (identity, conj, transpose, adjoint)
                    @test op2(op1(A3)) == op2(op1(B3))
                end
            end

            A4 = reshape(A1', (6, 10, 5, 12))
            @test isstrided(A4)
            B4 = StridedView(A4)
            B4[2, 2, 2, 2] = 3
            @test A4[2, 2, 2, 2] == 3
            for op1 in (identity, conj)
                @test op1(A4) == op1(B4)
                for op2 in (identity, conj)
                    @test op2(op1(A4)) == op2(op1(B4))
                end
            end

            A4 = reshape(view(A1, 1:36, 1:20), (6, 6, 5, 4))
            @test isstrided(A4)
            B4 = StridedView(A4)
            B4[2, 2, 2, 2] = 4
            @test A4[2, 2, 2, 2] == 4
            for op1 in (identity, conj)
                @test op1(A4) == op1(B4)
                for op2 in (identity, conj)
                    @test op2(op1(A4)) == op2(op1(B4))
                end
            end

            A4 = reshape(view(A1', 1:36, 1:20), (6, 6, 5, 4))
            B4 = StridedView(A4)
            B4[2, 2, 2, 2] = 5
            @test A4[2, 2, 2, 2] == 5
            for op1 in (identity, conj)
                @test op1(A4) == op1(B4)
                for op2 in (identity, conj)
                    @test op2(op1(A4)) == op2(op1(B4))
                end
            end

            A5 = PermutedDimsArray(reshape(view(A1, 1:36, 1:20), (6, 6, 5, 4)), (3, 1, 2, 4))
            @test isstrided(A5)
            B5 = StridedView(A5)
            for op1 in (identity, conj)
                @test op1(A5) == op1(B5)
                for op2 in (identity, conj)
                    @test op2(op1(A5)) == op2(op1(B5))
                end
            end

            A6 = reshape(view(A1, 1:36, 1:20), (6, 120))
            @test !isstrided(A6)
            @test_throws StridedViews.ReshapeException StridedView(A6)
            try
                StridedView(A6)
            catch ex
                println("Printing error message:")
                show(ex)
                println("")
            end

            # Array with Array elements
            A7 = [randn(T1, (5, 5)) for i in 1:5, j in 1:5]
            @test isstrided(A7)
            B7 = StridedView(A7)
            for op1 in (identity, conj, transpose, adjoint)
                @test op1(A7) == op1(B7) == StridedView(op1(A7))
                for op2 in (identity, conj, transpose, adjoint)
                    @test op2(op1(A7)) == op2(op1(B7))
                end
            end

            # Zero-dimensional array
            A8 = randn(T1, ())
            B8 = StridedView(A8)
            @test stride(B8, 1) == stride(B8, 5) == 1
            for op1 in (identity, conj)
                @test op1(A8) == op1(B8) == StridedView(op1(A8))
                for op2 in (identity, conj)
                    @test op2(op1(A8)) == op2(op1(B8))
                end
            end
            @test reshape(B8, (1, 1, 1)) == reshape(A8, (1, 1, 1)) ==
                StridedView(reshape(A8, (1, 1, 1))) == sreshape(A8, (1, 1, 1))
            @test reshape(B8, ()) == reshape(A8, ())
        end

        @test !isstrided(Diagonal([0.5, 1.0, 1.5]))
    end

    @testset "transpose and adjoint with vector StridedView" begin
        @testset for T in (Float32, Float64, Complex{Float32}, Complex{Float64})
            A = randn(T, (60,))

            @test sreshape(transpose(A), (1, length(A))) == transpose(A)
            @test sreshape(adjoint(A), (1, length(A))) == adjoint(A)
            @test isstrided(transpose(A))
            @test isstrided(adjoint(A))
        end
    end

    @testset "elementwise conj, transpose and adjoint" begin
        @testset for T in (Float32, Float64, Complex{Float32}, Complex{Float64})
            A = [rand(T) for i in 1:5, b in 1:4, c in 1:3, d in 1:2]
            B = StridedView(A)

            @test conj(B) == conj(A)
            @test conj(B) == map(conj, B)
            @test map(transpose, B) == map(transpose, A)
            @test map(adjoint, B) == map(adjoint, A)
        end
        @testset for T in (Float32, Float64, Complex{Float32}, Complex{Float64})
            A = [randn(T, (3, 3)) for i in 1:5, b in 1:4, c in 1:3, d in 1:2]
            B = StridedView(A)
            @test Base.elsize(B) == Base.elsize(A)

            @test conj(B) == conj(A)
            @test conj(B) == map(conj, B)
            @test map(transpose, B) == map(transpose, A)
            @test map(adjoint, B) == map(adjoint, A)
        end
    end

    @testset "reshape and permutedims with StridedView" begin
        @testset for T in (Float32, Float64, Complex{Float32}, Complex{Float64})
            A0 = randn(T, 10)
            @test permutedims(StridedView(A0), (1,)) == A0

            @testset "reshape and permutedims with $N-dimensional arrays" for N in 2:6
                let dims = ntuple(n -> rand(1:div(60, N)), N)
                    A = rand(T, dims)
                    B = StridedView(A)
                    @test conj(A) == conj(B)
                    p = randperm(N)
                    B2 = permutedims(B, p)
                    A2 = permutedims(A, p)
                    @test B2 == A2
                end

                let dims = ntuple(n -> 6, N)
                    A = rand(T, dims)
                    B = StridedView(A)
                    @test conj(A) == conj(B)
                    p = randperm(N)
                    B2 = permutedims(B, p)
                    A2 = permutedims(A, p)
                    @test B2 == A2

                    B2 = sreshape(B, (2, 3, ntuple(n -> 6, N - 2)..., 3, 2))
                    A2 = sreshape(A, (2, 3, ntuple(n -> 6, N - 2)..., 3, 2)...)
                    A3 = reshape(A, size(A2))
                    @test B2 == A3
                    @test B2 == A2
                    p = randperm(N + 2)
                    @test conj(permutedims(B2, p)) == conj(permutedims(A3, p))
                end
            end

            @testset "more reshape" begin
                A = randn(4, 0)
                B = StridedView(A)
                @test_throws DimensionMismatch sreshape(B, (4, 1))
                C = sreshape(B, (2, 1, 2, 0, 1))
                @test sreshape(C, (4, 0)) == A

                A = randn(4, 1, 2)
                B = StridedView(A)
                @test_throws DimensionMismatch sreshape(B, (4, 4))
                C = sreshape(B, (2, 1, 1, 4, 1, 1))
                @test C == reshape(A, (2, 1, 1, 4, 1, 1))
                @test sreshape(C, (4, 1, 2)) == A
            end
        end
    end

    @testset "views with StridedView" begin
        @testset for T in (Float32, Float64, ComplexF32, ComplexF64)
            A = randn(T, (10, 10, 10, 10))
            B = StridedView(A)
            @test isa(view(B, :, 1:5, 3, 1:5), StridedView)
            @test isa(view(B, :, [1, 2, 3], 3, 1:5), Base.SubArray)
            @test isa(sview(B, :, 1:5, 3, 1:5), StridedView)
            @test_throws MethodError sview(B, :, [1, 2, 3], 3, 1:5)

            @test view(A, 1:38) == view(B, 1:38) == sview(A, 1:38) == sview(B, 1:38)

            @test view(B, :, 1:5, 3, 1:5) == view(A, :, 1:5, 3, 1:5) == sview(A, :, 1:5, 3, 1:5)
            @test view(B, :, 1:5, 3, 1:5) === sview(B, :, 1:5, 3, 1:5) === B[:, 1:5, 3, 1:5]
            @test view(B, :, 1:5, 3, 1:5) == StridedView(view(A, :, 1:5, 3, 1:5))
            @test pointer(view(B, :, 1:5, 3, 1:5)) ==
                pointer(StridedView(view(A, :, 1:5, 3, 1:5)))
            @test StridedViews.offset(view(B, :, 1:5, 3, 1:5)) == 2 * stride(B, 3)
        end
    end

    @testset "reinterpretarray" begin
        struct MyComplex
            re::Float64
            im::Float64
        end
        a = MyComplex.(randn(5, 5, 5), randn(5, 5, 5))
        b = reinterpret(ComplexF64, a)
        sb = StridedView(b)
        csb = conj(sb)
        for index in CartesianIndices(a)
            @test sb[index] == a[index].re + im * a[index].im
            @test csb[index] == a[index].re - im * a[index].im
        end
        b2 = permutedims(reshape(sb, (25, 5)), (2, 1))
        cb2 = b2'
        a2 = permutedims(reshape(a, (25, 5)), (2, 1))
        for j in 1:size(b2, 2)
            for i in 1:size(b2, 1)
                @test b2[i, j] == a2[i, j].re + im * a2[i, j].im
                @test cb2[j, i] == a2[i, j].re - im * a2[i, j].im
            end
        end
    end

    @testset "PtrArrays with StridedView" begin
        @testset for T in (Float64, ComplexF64)
            A = randn!(PtrArrays.malloc(T, 10, 10, 10, 10))
            @test isstrided(A)
            B = StridedView(A)
            @test B isa StridedView
            @test B == A
            PtrArrays.free(A)
        end
    end

    @testset "JLArrays with StridedView" begin
        @testset for T in (Float64, ComplexF64)
            Araw = randn(T, 10, 10, 10, 10)
            A = JLArray(Araw)
            @test isstrided(A)
            B = StridedView(A)
            @test B isa StridedView
            JLArrays.@allowscalar begin
                @test B == A
            end
            Bvec = adapt(Vector{T}, B)
            @test Bvec == StridedView(Araw)
            @test parent(adapt(JLArray, Bvec)) isa JLArray
        end
    end

    Aqua.test_all(StridedViews)
end

if CUDACore.functional()
    @testset "CuArrays with StridedView" begin
        @testset for T in (Float64, ComplexF64)
            A = CUDACore.randn(T, 10, 10, 10, 10)
            @test isstrided(A)
            B = StridedView(A)
            @test B isa StridedView
            CUDACore.@allowscalar begin
                @test B == A
            end
        end
    end
end

if AMDGPU.functional()
    @testset "ROCArrays with StridedView" begin
        @testset for T in (Float64, ComplexF64)
            A = ROCArray(randn(T, 10, 10, 10, 10))
            @test isstrided(A)
            B = StridedView(A)
            @test B isa StridedView
            AMDGPU.@allowscalar begin
                @test B == A
            end
        end
    end
end

if Metal.functional()
    @testset "MtlArrays with StridedView" begin
        @testset for T in (Float32, ComplexF32)
            A = MtlArray(randn(T, 10, 10, 10, 10))
            @test isstrided(A)
            B = StridedView(A)
            @test B isa StridedView
            Metal.@allowscalar begin
                @test B == A
            end
        end
    end
end

!is_buildkite && include("jet/jet.jl")

# Precompilation workload
# ------------------------
# Cache the core `StridedView` specializations for the BLAS element types over a small
# range of dimensionalities and the op-wrappers a `StridedView` can carry. These are the
# specializations that downstream packages (e.g. TensorOperations / Strided) hit on their
# first call, so warming them here removes that first-call latency.
using PrecompileTools: @setup_workload, @compile_workload

@setup_workload begin
    @compile_workload begin
        for T in (Float32, Float64, ComplexF32, ComplexF64)
            # construction + property queries + core ops for ndims 1:4
            for N in 1:6
                A = Array{T, N}(undef, ntuple(_ -> 2, N))
                sv = StridedView(A)
                size(sv)
                strides(sv)
                offset(sv)
                csv = conj(sv)
                # permute through the identity permutation (exercises the per-N path)
                permutedims(sv, ntuple(identity, N))
                permutedims(csv, ntuple(identity, N))
                # reshape to a flat vector and back (also exercises sview on the flat view)
                flat = sreshape(sv, (length(sv),))
                sview(flat, 1:length(sv))
                getindex(sv, ntuple(_ -> 1, N)...)
                flat = sreshape(csv, (length(sv),))
                sview(flat, 1:length(csv))
                getindex(csv, ntuple(_ -> 1, N)...)
            end
            # 2D matrix wrappers: transpose / adjoint
            M = Array{T, 2}(undef, 2, 2)
            svM = StridedView(M)
            transpose(svM)
            adjoint(svM)
            # a representative 4D slice view (the SliceIndex `getindex` construction path)
            A4 = Array{T, 4}(undef, 2, 2, 2, 2)
            sv4 = StridedView(A4)
            getindex(sv4, :, 1:2, 1, 1:2)
        end
    end
end

module StridedViewsCUDAExt

using StridedViews
using CUDA
using CUDA: Adapt, CuPtr

const CuStridedView{T,N,A<:CuArray{T}} = StridedView{T,N,A}

function Adapt.adapt_structure(::Type{T}, A::StridedView) where {T}
    return StridedView(Adapt.adapt_structure(T, parent(A)),
                       A.size, A.strides, A.offset, A.op)
end

function Base.pointer(x::CuStridedView{T}) where {T}
    return Base.unsafe_convert(CuPtr{T}, pointer(x.parent, x.offset + 1))
end
function Base.unsafe_convert(::Type{CuPtr{T}}, a::CuStridedView{T}) where {T}
    return convert(CuPtr{T}, pointer(a))
end

function Base.print_array(io::IO, X::CuStridedView)
    return Base.print_array(io, Adapt.adapt_structure(Array, X))
end

end # module

module StridedViewsCUDACoreExt

using StridedViews
using CUDACore
using CUDACore: Adapt, CuPtr

const CuStridedView{T, N, A <: CuArray{T}} = StridedView{T, N, A}

function Base.pointer(x::CuStridedView{T}) where {T}
    return Base.unsafe_convert(CuPtr{T}, pointer(x.parent, x.offset + 1))
end
function Base.unsafe_convert(::Type{CuPtr{T}}, a::CuStridedView{T}) where {T}
    return convert(CuPtr{T}, pointer(a))
end

function Base.print_array(io::IO, X::CuStridedView)
    return Base.print_array(io, Adapt.adapt(Array, X))
end

end # module

# Auxiliary routines
#---------------------
# Check whether p is a valid permutation of length N
_isperm(N::Integer, p::AbstractVector) = (length(p) == N && isperm(p))
_isperm(N::Integer, p::NTuple{M, Integer}) where {M} = (M == N && isperm(p))
_isperm(N::Integer, p) = false

# Compute the memory index given a list of cartesian indices and corresponding strides
@inline function _computeind(indices::NTuple{N, Int}, strides::NTuple{N, Int}) where {N}
    return (indices[1] - 1) * strides[1] + _computeind(tail(indices), tail(strides))
end
_computeind(indices::Tuple{}, strides::Tuple{}) = 1

# 'Simplify' the dimensions of a `StridedView` to represent it with the largest possible
# contiguous dimensions (thereby potentially fusing subsequent dimensions), without changing
# the order of the elements. For type stability, we do not remove dimensions but replace
# them with dimensions of size 1 and move all of those to the end.
_simplifydims(size::Tuple{}, strides::Tuple{}) = size, strides
_simplifydims(size::Dims{1}, strides::Dims{1}) = size, strides
function _simplifydims(size::Dims{N}, strides::Dims{N}) where {N}
    tailsize, tailstrides = _simplifydims(tail(size), tail(strides))
    if size[1] == 1
        return (tailsize..., 1), (tailstrides..., 1)
    elseif size[1] * strides[1] == tailstrides[1]
        return (size[1] * tailsize[1], tail(tailsize)..., 1),
            (strides[1], tail(tailstrides)..., 1)
    else
        return (size[1], tailsize...), (strides[1], tailstrides...)
    end
end

# 'Normalize' the strides of a `StridedView`, i.e. strides associated with dimensions of
# size 1 have no intrinsic meaning and can be changed arbitrarily. If one of the dimensions
# has size zero, then the whole array has length zero, and all strides are ambiguous. All
# ambiguous strides are set to 1.
function _normalizestrides(size::Dims{N}, strides::Dims{N}) where {N}
    for i in 1:N
        if size[i] == 1
            newstride = i == 1 ? 1 : strides[i - 1] * size[i - 1]
            strides = Base.setindex(strides, newstride, i)
        elseif size[i] == 0
            return (1, Base.front(cumprod(size))...)
        end
    end
    return strides
end

# 'Normalize' the layout of a DenseArray, in order to reduce the number of required
# specializations in functions.
@inline _normalizeparent(A) = A
@static if isdefined(Core, :Memory)
    @inline _normalizeparent(A::Array) = A.ref.mem
else
    @inline _normalizeparent(A::Array) = reshape(A, length(A))
end

# Auxiliary methods for `sview`
#------------------------------
# Compute the new dimensions of a strided view given the original size and the view slicing
# indices
@inline function _computeviewsize(oldsize::NTuple{N, Int}, I::NTuple{N, SliceIndex}) where {N}
    if isa(I[1], Int)
        return _computeviewsize(tail(oldsize), tail(I))
    elseif isa(I[1], Colon)
        return (oldsize[1], _computeviewsize(tail(oldsize), tail(I))...)
    else
        return (length(I[1]), _computeviewsize(tail(oldsize), tail(I))...)
    end
end
_computeviewsize(::Tuple{}, ::Tuple{}) = ()

# Compute the new strides of a (strided) view given the original strides and the view
# slicing indices
@inline function _computeviewstrides(
        oldstrides::NTuple{N, Int},
        I::NTuple{N, SliceIndex}
    ) where {N}
    if isa(I[1], Integer)
        return _computeviewstrides(tail(oldstrides), tail(I))
    elseif isa(I[1], Colon)
        return (oldstrides[1], _computeviewstrides(tail(oldstrides), tail(I))...)
    else
        return (
            oldstrides[1] * step(I[1]),
            _computeviewstrides(tail(oldstrides), tail(I))...,
        )
    end
end
_computeviewstrides(::Tuple{}, ::Tuple{}) = ()

# Compute the additional offset of a (strided) view given the original strides and the view
# slicing indices
@inline function _computeviewoffset(
        strides::NTuple{N, Int},
        I::NTuple{N, SliceIndex}
    ) where {N}
    if isa(I[1], Colon)
        return _computeviewoffset(tail(strides), tail(I))
    else
        return (first(I[1]) - 1) * strides[1] + _computeviewoffset(tail(strides), tail(I))
    end
end
_computeviewoffset(::Tuple{}, ::Tuple{}) = 0

# Auxiliary methods for `sreshape`
#----------------------------------
# Compute the new strides of a (strided) reshape given the original strides and new and
# original sizes
_computereshapestrides(newsize::Tuple{}, oldsize::Tuple{}, strides::Tuple{}) = strides
function _computereshapestrides(
        newsize::Tuple{}, oldsize::Dims{N},
        strides::Dims{N}
    ) where {N}
    all(isequal(1), oldsize) || throw(DimensionMismatch())
    return ()
end
function _computereshapestrides(newsize::Dims, oldsize::Tuple{}, strides::Tuple{})
    all(isequal(1), newsize) || throw(DimensionMismatch())
    return newsize
end
function _computereshapestrides(newsize::Dims, oldsize::Dims{N}, strides::Dims{N}) where {N}
    d, r = divrem(oldsize[1], newsize[1])
    return if r == 0
        s1 = strides[1]
        if d == 1
            # not shrinking the following tuples helps type inference
            oldsize = (tail(oldsize)..., 1)
            strides = (tail(strides)..., 1)
            stail = _computereshapestrides(tail(newsize), oldsize, strides)
            return isnothing(stail) ? nothing : (s1, stail...)
        else
            oldsize = (d, tail(oldsize)...)
            strides = (newsize[1] * s1, tail(strides)...)
            stail = _computereshapestrides(tail(newsize), oldsize, strides)
            return isnothing(stail) ? nothing : (s1, stail...)
        end
    else
        if prod(newsize) != prod(oldsize)
            throw(DimensionMismatch())
        else
            return nothing
        end
    end
end

module StridedViewsMetalExt

using StridedViews
using Metal
using Metal: Adapt, MtlPtr

const MtlStridedView{T, N, A <: MtlArray{T}} = StridedView{T, N, A}

function Base.pointer(x::MtlStridedView{T}) where {T}
    return Base.unsafe_convert(MtlPtr{T}, pointer(x.parent, x.offset + 1))
end
function Base.unsafe_convert(::Type{MtlPtr{T}}, a::MtlStridedView{T}) where {T}
    return convert(MtlPtr{T}, pointer(a))
end

function Base.print_array(io::IO, X::MtlStridedView)
    return Base.print_array(io, Adapt.adapt(Array, X))
end

end # module

################## StridedView.jl #
##################
# Defines the main type of this package and its functionality

# Preliminary:
#--------------
# Additional view flags and their transformation behaviour
const FN = typeof(identity)
const FC = typeof(conj)
const FA = typeof(adjoint)
const FT = typeof(transpose)
_conj(::FN) = conj
_conj(::FC) = identity
_conj(::FA) = transpose
_conj(::FT) = adjoint
_transpose(::FN) = transpose
_transpose(::FC) = adjoint
_transpose(::FA) = conj
_transpose(::FT) = identity
_adjoint(::FN) = adjoint
_adjoint(::FC) = transpose
_adjoint(::FA) = identity
_adjoint(::FT) = conj

# StridedView type definition
#-----------------------------
struct StridedView{T, N, A <: DenseArray, F <: Union{FN, FC, FA, FT}} <: AbstractArray{T, N}
    parent::A
    size::NTuple{N, Int}
    strides::NTuple{N, Int}
    offset::Int
    op::F
end

# Constructors
#--------------
function StridedView(
        parent::DenseArray,
        size::NTuple{N, Int} = size(parent),
        strides::NTuple{N, Int} = strides(parent),
        offset::Int = 0,
        op::F = identity
    ) where {N, F}
    T = Base.promote_op(op, eltype(parent))
    return StridedView{T}(parent, size, strides, offset, op)
end
function StridedView{T}(
        parent::DenseArray,
        size::NTuple{N, Int} = size(parent),
        strides::NTuple{N, Int} = strides(parent),
        offset::Int = 0,
        op::F = identity
    ) where {T, N, F}
    parent′ = _normalizeparent(parent)
    strides′ = _normalizestrides(size, strides)
    return StridedView{T, N, typeof(parent′), F}(parent′, size, strides′, offset, op)
end

StridedView(a::StridedView) = a
StridedView(a::Adjoint) = StridedView(a')'
StridedView(a::Transpose) = transpose(StridedView(transpose(a)))
StridedView(a::Base.SubArray) = sview(StridedView(a.parent), a.indices...)
StridedView(a::Base.ReshapedArray) = sreshape(StridedView(a.parent), a.dims)
function StridedView(a::Base.PermutedDimsArray{T, N, P}) where {T, N, P}
    return permutedims(StridedView(a.parent), P)
end
function StridedView(a::Base.ReinterpretArray{T, N}) where {T, N}
    b = StridedView(a.parent)
    S = eltype(b)
    isbitstype(T) && isbitstype(S) && sizeof(T) == sizeof(S) ||
        throw(ArgumentError("Cannot create StridedView with reinterpretation from $S to $T"))
    b.op isa FN ||
        throw(ArgumentError("Cannot create StridedView with reinterpretation from view with non-identity operation"))
    return StridedView{T}(b.parent, size(b), strides(b), offset(b))
end

# trait
isstrided(a::DenseArray) = true
isstrided(a::StridedView) = true
isstrided(a::Adjoint) = isstrided(a')
isstrided(a::Transpose) = isstrided(transpose(a))
function isstrided(a::Base.SubArray)
    return isstrided(a.parent) && all(Base.Fix2(isa, SliceIndex), a.indices)
end
function isstrided(a::Base.ReshapedArray)
    isstrided(a.parent) || return false
    newsize = a.dims
    oldsize = size(a.parent)
    any(isequal(0), newsize) && return true
    newstrides = _computereshapestrides(
        newsize,
        _simplifydims(oldsize, _strides(a.parent))...
    )
    return !isnothing(newstrides)
end
isstrided(a::Base.PermutedDimsArray) = isstrided(a.parent)
isstrided(a::AbstractArray) = false

# work around annoying Base behavior: it doesn't define strides for complex adjoints
# because of the recursiveness of the definitions, we need to redefine all of them
_strides(a::DenseArray) = strides(a)
_strides(a::Adjoint{<:Any, <:AbstractVector}) = (stride(a.parent, 2), stride(a.parent, 1))
_strides(a::Adjoint{<:Any, <:AbstractMatrix}) = reverse(strides(a.parent))
_strides(a::Transpose{<:Any, <:AbstractVector}) = (stride(a.parent, 2), stride(a.parent, 1))
_strides(a::Transpose{<:Any, <:AbstractMatrix}) = reverse(strides(a.parent))
function _strides(a::PermutedDimsArray{T, N, perm}) where {T, N, perm}
    s = _strides(parent(a))
    return ntuple(d -> s[perm[d]], Val(N))
end
_strides(a::SubArray) = Base.substrides(_strides(a.parent), a.indices)

# Elementary properties
#-----------------------
Base.size(a::StridedView) = a.size
Base.strides(a::StridedView) = a.strides
Base.stride(a::StridedView{<:Any, 0}, n::Int) = 1
function Base.stride(a::StridedView{<:Any, N}, n::Int) where {N}
    return (n <= N) ? a.strides[n] : a.strides[N] * a.size[N]
end
offset(a::StridedView) = a.offset
Base.parent(a::StridedView) = a.parent

# Indexing methods
#------------------
Base.IndexStyle(::Type{<:StridedView}) = Base.IndexCartesian()

# Indexing with N integer arguments
@inline function Base.getindex(a::StridedView{<:Any, N}, I::Vararg{Int, N}) where {N}
    @boundscheck checkbounds(a, I...)
    i = ParentIndex(a.offset + _computeind(I, a.strides))
    @inbounds r = getindex(a, i)
    return r
end
@inline function Base.setindex!(a::StridedView{<:Any, N}, v, I::Vararg{Int, N}) where {N}
    @boundscheck checkbounds(a, I...)
    i = ParentIndex(a.offset + _computeind(I, a.strides))
    @inbounds setindex!(a, v, i)
    return a
end

# Indexing with slice indices to create a new view.
function Base.getindex(a::StridedView{T, N}, I::Vararg{SliceIndex, N}) where {T, N}
    return StridedView{T}(
        a.parent,
        _computeviewsize(a.size, I),
        _computeviewstrides(a.strides, I),
        a.offset + _computeviewoffset(a.strides, I),
        a.op
    )
end

# Indexing directly into parent array
struct ParentIndex
    i::Int
end
@propagate_inbounds function Base.getindex(a::StridedView, I::ParentIndex)
    S = Base.promote_op(a.op, eltype(a))
    v = getindex(a.parent, I.i)
    return a.op(v isa S ? v : reinterpret(S, v))
end
@propagate_inbounds function Base.setindex!(a::StridedView, v, I::ParentIndex)
    T = eltype(a)
    v = a.op(convert(T, v))
    S = eltype(a.parent)
    setindex!(a.parent, v isa S ? v : reinterpret(S, v), I.i)
    return a
end

# Specific Base methods that are guaranteed to preserve`StridedView` objects
#----------------------------------------------------------------------------
Base.conj(a::StridedView{<:Real}) = a
function Base.conj(a::StridedView{T}) where {T <: Complex}
    return StridedView{T}(a.parent, a.size, a.strides, a.offset, _conj(a.op))
end
function Base.conj(a::StridedView)
    S = Base.promote_op(a.op, eltype(a))
    newop = _conj(a.op)
    T = Base.promote_op(newop, S)
    return StridedView{T}(a.parent, a.size, a.strides, a.offset, newop)
end

function Base.permutedims(a::StridedView{T, N}, p) where {T, N}
    _isperm(N, p) || throw(ArgumentError("Invalid permutation of length $N: $p"))
    newsize = ntuple(n -> size(a, p[n]), Val(N))
    newstrides = ntuple(n -> stride(a, p[n]), Val(N))
    return StridedView{T}(a.parent, newsize, newstrides, a.offset, a.op)
end

LinearAlgebra.transpose(a::StridedView{<:Number, 2}) = permutedims(a, (2, 1))
LinearAlgebra.adjoint(a::StridedView{<:Number, 2}) = permutedims(conj(a), (2, 1))
function LinearAlgebra.adjoint(a::StridedView{<:Any, 2}) # act recursively, like Base
    S = Base.promote_op(a.op, eltype(a))
    newop = _adjoint(a.op)
    T = Base.promote_op(newop, S)
    return permutedims(StridedView{T}(a.parent, a.size, a.strides, a.offset, newop), (2, 1))
end
function LinearAlgebra.transpose(a::StridedView{<:Any, 2}) # act recursively, like Base
    S = Base.promote_op(a.op, eltype(a))
    newop = _transpose(a.op)
    T = Base.promote_op(newop, S)
    return permutedims(StridedView{T}(a.parent, a.size, a.strides, a.offset, newop), (2, 1))
end

Base.map(::FC, a::StridedView{<:Real}) = a
Base.map(::FT, a::StridedView{<:Number}) = a
Base.map(::FA, a::StridedView{<:Number}) = conj(a)
function Base.map(::FC, a::StridedView)
    T = Base.promote_op(conj, eltype(a))
    return StridedView{T}(a.parent, a.size, a.strides, a.offset, _conj(a.op))
end
function Base.map(::FT, a::StridedView)
    T = Base.promote_op(transpose, eltype(a))
    return StridedView{T}(a.parent, a.size, a.strides, a.offset, _transpose(a.op))
end
function Base.map(::FA, a::StridedView)
    T = Base.promote_op(adjoint, eltype(a))
    return StridedView{T}(a.parent, a.size, a.strides, a.offset, _adjoint(a.op))
end

# Creating or transforming StridedView by slicing
#-------------------------------------------------
# we cannot use Base.view, as this also accepts indices that might not preserve stridedness
sview(a::StridedView{<:Any, N}, I::Vararg{SliceIndex, N}) where {N} = getindex(a, I...)
sview(a::StridedView, I::SliceIndex) = getindex(sreshape(a, (length(a),)), I)

# for StridedView and index arguments which preserve stridedness, we do replace Base.view
# with sview
Base.view(a::StridedView{<:Any, N}, I::Vararg{SliceIndex, N}) where {N} = getindex(a, I...)

# `sview` can be used as a constructor when acting on `AbstractArray` objects
function sview(a::AbstractArray{<:Any, N}, I::Vararg{SliceIndex, N}) where {N}
    return getindex(StridedView(a), I...)
end
function sview(a::AbstractArray, I::SliceIndex)
    return getindex(sreshape(StridedView(a), (length(a),)), I)
end

# Creating or transforming StridedView by reshaping
#---------------------------------------------------
# An error struct for non-strided reshapes
struct ReshapeException{N₁, N₂} <: Exception
    newsize::Dims{N₁}
    oldsize::Dims{N₂}
    strides::Dims{N₂}
end
function Base.show(io::IO, e::ReshapeException)
    msg = "Cannot reshape a StridedView with size $(e.oldsize) and strides $(e.strides) to newsize=$(e.newsize) without allocating, try `sreshape(copy(array), newsize)` or fall back to `reshape(array, newsize)`."
    return print(io, msg)
end

# we cannot use Base.reshape, as this also accepts indices that might not preserve stridedness
sreshape(a, args::Vararg{Int}) = sreshape(a, args)
function sreshape(a::StridedView{T}, newsize::Dims) where {T}
    if any(isequal(0), newsize)
        any(isequal(0), size(a)) || throw(DimensionMismatch())
        newstrides = one.(newsize)
    else
        newstrides = _computereshapestrides(newsize, _simplifydims(size(a), strides(a))...)
    end
    isnothing(newstrides) && throw(ReshapeException(newsize, size(a), strides(a)))
    return StridedView{T}(a.parent, newsize, newstrides, a.offset, a.op)
end

sreshape(a::AbstractArray, newsize::Dims) = sreshape(StridedView(a), newsize)

function sreshape(a::LinearAlgebra.AdjointAbsVec, newsize::Dims)
    return sreshape(conj(StridedView(adjoint(a))), newsize)
end
function sreshape(a::LinearAlgebra.TransposeAbsVec, newsize::Dims)
    return sreshape(StridedView(transpose(a)), newsize)
end

# Other methods: `similar`, `copy`
#----------------------------------
function Base.similar(a::StridedView, ::Type{T}, dims::NTuple{N, Int}) where {N, T}
    return StridedView(similar(a.parent, T, dims))
end
Base.copy(a::StridedView) = copyto!(similar(a), a)

# Memory information of a `StridedView`
#---------------------------------------
function Base.unsafe_convert(::Type{Ptr{T}}, a::StridedView{T}) where {T}
    return convert(Ptr{T}, pointer(a.parent, a.offset + 1))
end
function Base.elsize(::Type{<:StridedView{T, N, A}}) where {T, N, A}
    return Base.elsize(A)
end
Base.dataids(a::StridedView) = Base.dataids(a.parent)

module StridedViewsAMDGPUExt

using StridedViews
using AMDGPU
using AMDGPU: Adapt

const ROCStridedView{T, N, A <: ROCArray{T}} = StridedView{T, N, A}

function Base.pointer(x::ROCStridedView{T}) where {T}
    return Base.unsafe_convert(Ptr{T}, pointer(x.parent, x.offset + 1))
end
function Base.unsafe_convert(::Type{Ptr{T}}, a::ROCStridedView{T}) where {T}
    return convert(Ptr{T}, pointer(a))
end

function Base.print_array(io::IO, X::ROCStridedView)
    return Base.print_array(io, Adapt.adapt(Array, X))
end

end # module

module StridedViews

import Base: parent, size, strides, tail, setindex
using Base: @propagate_inbounds, RangeIndex, Dims
const SliceIndex = Union{RangeIndex, Colon}

using LinearAlgebra
export StridedView, sreshape, sview, isstrided

include("auxiliary.jl")
include("stridedview.jl")
include("precompile.jl")

end

@testset "JET" begin
    import Pkg
    try
        Pkg.activate(joinpath(@__DIR__); io = devnull)
        Pkg.develop(Pkg.PackageSpec(path = joinpath(@__DIR__, "..", "..")); io = devnull)
        Pkg.instantiate(; io = devnull)
        @eval import JET
        JET.test_package(StridedViews; target_modules = (StridedViews,))
    catch e
        e isa Pkg.Types.PkgError || rethrow()
        @test_broken false
    finally
        Pkg.activate(@__DIR__; io = devnull)
    end
end
